/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mouse Gesture for Mozilla.
 *
 * The Initial Developer of the Original Code is Pavol Vaskovic.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Edmonds <aedmonds@mindspring.com> 
 *  Pavol Vaskovic <pali@pali.sk>
 *  Steve Kangas <bookmarklets.com> FIXME  email
 *  Squarefree.com     FIXME who exactly: whole name, email
 *  Scurrie            FIXME whole name, email
 *  Exotrip            FIXME whole name, email
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
 // ----------------------
// doSearchHighLight()
//
// This function is an extremely nasty hack that will highlight instances
// of a word entered in the search bar in the browser window.
//
// Things a proper version would need to do:
//   + Turn off highlighting?
//   + Toggled button (ie stay on accross pages while toggled on)?
//   + Handle frames  
//   + Be more intelligent/customisable on the highlighting style.
//   + Be less crufty
//
// Paul McGarry <mcgarry@tig.com.au>
//
// 	var sidebarSearchText; //= document.getElementById("sidebar-search-text");
// ----------------------
function doSearchHighLight(sidebarSearchText)
{

	var wordArray=sidebarSearchText.split(" ");
	for (x=0;x<wordArray.length;x++)
	{
		re = new RegExp(wordArray[x],"i");
		len=wordArray[x].length;	
		processTextNodes(window._content.document.documentElement,re,len)
	}
}


// This function is recursively called to cascade through all the nodes in the document.
function processTextNodes(node, re,len)
{
	skip=0;

	if ( node.nodeName == "#text" )
	{
		if (node.data.search(re)>=0)
		{
			spannode= document.createElement("SPAN");
			//spannode.setAttribute('style','display: inline; background-color: yellow;');
			spannode.className = "highlighted";
			middlebit=node.splitText(node.data.search(re));
			endbit=middlebit.splitText(len);

			middleclone=middlebit.cloneNode(true);
			spannode.appendChild(middleclone);
			middlebit.parentNode.replaceChild(spannode,middlebit)
			// As we've actually created a new node which contains the search
         // text, we have to make sure we skip it on the next loop.
			skip=1;
		}
	}	
	
	// children of nodes (other than frames)
	if ( node.childNodes )
	{
		for ( var child = 0; child < node.childNodes.length; child++ )
		{
			child=child + processTextNodes(node.childNodes[child], re,len);
		}
	} 
	return skip;
}


